# flake8: noqa

"""
    Purplship API

    The version of the OpenAPI document: 2021.10
    Contact: hello@purplship.com
    Generated by: https://openapi-generator.tech
"""


__version__ = "2021.10"

import typing

# import ApiClient
from purplship.api_client import ApiClient

# import Configuration
from purplship.configuration import Configuration

# import exceptions
from purplship.exceptions import OpenApiException
from purplship.exceptions import ApiAttributeError
from purplship.exceptions import ApiTypeError
from purplship.exceptions import ApiValueError
from purplship.exceptions import ApiKeyError
from purplship.exceptions import ApiException

# import apis into sdk package
from purplship.api.api_api import APIApi
from purplship.api.addresses_api import AddressesApi
from purplship.api.carriers_api import CarriersApi
from purplship.api.customs_api import CustomsApi
from purplship.api.parcels_api import ParcelsApi
from purplship.api.pickups_api import PickupsApi
from purplship.api.proxy_api import ProxyApi
from purplship.api.shipments_api import ShipmentsApi
from purplship.api.trackers_api import TrackersApi
from purplship.api.webhooks_api import WebhooksApi


api_key = None
api_key_prefix = 'Token'
host = 'https://cloud.purplship.com'
api_client = None
configuration = Configuration()


def init_client():
    global api_client
    global configuration
    if (api_client is not None) and (configuration.host == host) \
            and (configuration.api_key['Token'] == f'{api_key}'):
        return api_client

    configuration = Configuration()
    configuration.host = host
    configuration.api_key['Token'] = f'{api_key}'
    configuration.api_key_prefix['Token'] = f'{api_key_prefix}'
    
    api_client = ApiClient(configuration)

    return api_client


def define_api(api_class: typing.Type):
    class _API(api_class):
        def __init__(self):
            pass

        def __getattribute__(self, item):
            return getattr(api_class(init_client()), item)

    return _API()


api = define_api(APIApi)
addresses = define_api(AddressesApi)
carriers = define_api(CarriersApi)
customs = define_api(CustomsApi)
parcels = define_api(ParcelsApi)
pickups = define_api(PickupsApi)
proxy = define_api(ProxyApi)
shipments = define_api(ShipmentsApi)
trackers = define_api(TrackersApi)
webhooks = define_api(WebhooksApi)
